unit uInfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, uMain;

type

  { TfrmInfo }

  TfrmInfo = class(TForm)
    lblZipFileNameVal: TLabel;
    lblZipInArchiveVal: TLabel;
    lblSizePackedVal: TLabel;
    lblSizeUnpackedVal: TLabel;
    lblCompressRateVal: TLabel;
    lblSizeUnpacked: TLabel;
    lblCompressRate: TLabel;
    lblFileComment: TLabel;
    lblZipFileName: TLabel;
    lblFilesInArchive: TLabel;
    lblSizePacked: TLabel;
    MemoComment: TMemo;
    panCompressRate: TPaintBox;
    procedure FormShow(Sender: TObject);
    procedure panCompressRatePaint(Sender: TObject);
  private
    procedure ShowZipInfo;
  public

  end;

var
  frmInfo: TfrmInfo;


implementation

{$R *.lfm}

{ TfrmInfo }

procedure TfrmInfo.panCompressRatePaint(Sender: TObject);
var
  rGreen, rRed: TRect;
  fRateValue: Integer;
begin
  fRateValue := 3 * frmMain.aZipInfo.CompressRate;

  rGreen := Rect(1, 1, 301, 25);
  rRed   := Rect(1, 1, fRateValue + 1, 25);

  with panCompressRate.Canvas do begin
    Font.Size := 10;
    Font.Name := 'default';
    Font.Quality := fqDefault;
    Font.Style := [fsBold];
    Pen.Color := clBlack;
    Rectangle(0,0,302,26);
    GradientFill(rGreen, RGBToColor(255,255,255), RGBToColor(0,255,0), gdVertical);
    GradientFill(rRed, RGBToColor(255,0,0), RGBToColor(255,255,255), gdVertical);
    TextRect(rGreen, 135, 4, Format('%d%%', [frmMain.aZipInfo.CompressRate]));
  end;

end;

procedure TfrmInfo.FormShow(Sender: TObject);
begin
  ShowZipInfo;
end;

procedure TfrmInfo.ShowZipInfo;
begin
  lblZipFileNameVal.Caption  := Format('%s'  , [frmMain.aZipInfo.ZipFileName]);
  lblZipInArchiveVal.Caption := Format('%d'  , [frmMain.aZipInfo.FilesInArchive]);
  lblSizePackedVal.Caption   := Format('%.0n', [frmMain.aZipInfo.SizePacked * 1.0]);
  lblSizeUnpackedVal.Caption := Format('%.0n', [frmMain.aZipInfo.SizeUnpacked * 1.0]);
  lblCompressRateVal.Caption := Format('%d%%', [frmMain.aZipInfo.CompressRate]);
  MemoComment.Text := frmMain.aZipInfo.FileComment;
end;


end.

